<?php

/**
 * @author Cyrex/CORE
 * @copyright 2011
 */

class p_votes extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        //   

        $this->info['plugin']           = 'p_votes';
        $this->info['title']            = '  ';
        $this->info['description']      = '       ,        ';
        $this->info['author']           = ' ';
        $this->info['version']          = '1.0';

        // ,    

        $this->events[]                 = 'GET_PHOTO';
        $this->events[]                 = 'GET_USER_PHOTO';
    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){
$inDB   = cmsDatabase::getInstance();
$sql = "
CREATE TABLE `cms_votes_photo` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `points` int(11) NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '1',
  `to_userid` int(11) NOT NULL DEFAULT '1',
  `pubdate` datetime NOT NULL,
  `ip` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `to_userid` (`to_userid`),
  KEY `item_id` (`item_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1;";
$inDB->query($sql) ;
$sql = "
CREATE TABLE `cms_votes_photo_total` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` mediumint(9) NOT NULL,
  `total_votes` int(11) NOT NULL,
  `total_voice` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item_id` (`item_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1;
";
 $inDB->query($sql) ;
 $sql = "
CREATE TABLE `cms_votes_userphoto` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `points` int(11) NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '1',
  `to_userid` int(11) NOT NULL DEFAULT '1',
  `pubdate` datetime NOT NULL,
  `ip` varchar(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `to_userid` (`to_userid`),
  KEY `item_id` (`item_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1;";
$inDB->query($sql) ;
$sql = "
CREATE TABLE `cms_votes_userphoto_total` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` mediumint(9) NOT NULL,
  `total_votes` int(11) NOT NULL,
  `total_voice` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item_id` (`item_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=cp1251 AUTO_INCREMENT=1;
";
 $inDB->query($sql) ;
        return parent::install();

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //
    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_PHOTO': $item = $this->eventGetPhoto($item); break;
            case 'GET_USER_PHOTO': $item = $this->eventGetUserPhoto($item); break;
        }

        return $item;

    }

// ==================================================================== //

    private function eventGetPhoto($item) {
    $item_id    = $item['id'];
    $inUser = cmsUser::getInstance();
    $to_userid  = $inUser->id;
    $inDB = cmsDatabase::getInstance();

        $sql = "SELECT t.total_votes / t.total_voice AS bal
                         , t.total_voice AS golosov
                         , v.points as points
                    FROM
                      cms_votes_photo v
                    RIGHT JOIN cms_votes_photo_total t ON v.item_id = t.item_id
                    WHERE
                      v.item_id = '{$item['id']}' AND v.to_userid = '$to_userid'";                 

        $results = $inDB->query($sql);

        while($usr = $inDB->fetch_assoc($results)){
       $bal     = round($usr['bal'],1);
        $points  = $usr['points'];
        $golosov = $usr['golosov'];
        }
        
        if ($points =='') {
        	 $sql = "SELECT t.total_votes / t.total_voice AS bal
                      , t.total_voice AS golosov
                    FROM
                      cms_votes_photo_total t
                    WHERE
                      t.item_id = '{$item['id']}'";   

        $results = $inDB->query($sql);

            while($usr = $inDB->fetch_assoc($results)){
            $bal     = ceil($usr['bal']);
            $points  = $usr['points'];
            $golosov = $usr['golosov'];
            }
        }

    ob_start();

        $smarty= $this->inCore->initSmarty('plugins', 'p_votes.tpl');
        $smarty->assign('item_id', $item_id);
        $smarty->assign('to_userid', $to_userid);
        $smarty->assign('bal', $bal);
        $smarty->assign('points', $points);
        $smarty->assign('golosov', $golosov);
        $smarty->display('p_votes.tpl');

        $html = ob_get_clean();

        $item['content_html'] .= $html;

        return $item;
    }
    
  private function eventGetUserPhoto($item) {
    $item_id    = $item['id'];
    $album_id   = $item['album_id'];//******
    $user_id    = $item['user_id'];//*******
    $inUser     = cmsUser::getInstance();
    $to_userid  = $inUser->id;
    $inDB = cmsDatabase::getInstance(); 
  
                  
        $sql = "SELECT t.total_votes / t.total_voice AS bal
                         , t.total_voice AS golosov
                         , v.points as points
                    FROM
                      cms_votes_userphoto v
                    RIGHT JOIN cms_votes_userphoto_total t ON v.item_id = t.item_id
                    WHERE
                      v.item_id = '{$item['id']}' AND v.to_userid = '$to_userid'";                 

        $results = $inDB->query($sql);

        while($usr = $inDB->fetch_assoc($results)){
            $bal_user_photo     = ceil($usr['bal']);
            $points_user_photo  = $usr['points'];
            $golosov_user_photo = $usr['golosov'];
        }
        
        if ($points_user_photo =='') {
        	 $sql = "SELECT t.total_votes / t.total_voice AS bal
                      , t.total_voice AS golosov
                    FROM
                      cms_votes_userphoto_total t
                    WHERE
                      t.item_id = '{$item['id']}'";   

        $results = $inDB->query($sql);

            while($usr = $inDB->fetch_assoc($results)){
            $bal_user_photo     = ceil($usr['bal']);
            $golosov_user_photo = $usr['golosov'];
            }
        }

        $sql = "SELECT id, imageurl as file, hits
                FROM 
                    cms_user_photos
                WHERE   
                    user_id = '$user_id' AND album_id = '$album_id' 
                ORDER BY id DESC";
        $results = $inDB->query($sql);

            while($alb = $inDB->fetch_assoc($results)){
               $url = '/users/'.$user_id.'/photo'.$alb['id'].'.html'; 
              $album[] = $alb;
            }

    ob_start();
        $smarty= $this->inCore->initSmarty('plugins', 'p_votes.tpl');
        $smarty->assign('item_id', $item_id);
        $smarty->assign('to_userid', $to_userid);
        $smarty->assign('album_id', $album_id);
        $smarty->assign('bal_user_photo', $bal_user_photo);
        $smarty->assign('points_user_photo', $points_user_photo);
        $smarty->assign('golosov_user_photo', $golosov_user_photo);
        $smarty->assign('album', $album);
        $smarty->display('p_votes.tpl');

        $html = ob_get_clean();

        $item['content_html'] .= $html;

        return $item;
    }

}

?>